import java.dyn.*;

public class DynamicInvocation {

    public static void main(String... args) {

        // Statically invoke the geeeter(String) method
        greeter("static invocation");

        // The below line generates invokevirtual MethodHandle.invoke(String)void
        greeterMethodHandle.<void>invoke("virtual invocation"); // Strongly typed direct call

        // The below line generates invokedynamic MethodHandle.invoke(Object)Object
        InvokeDynamic.hail("dynamic invocation"); // Weakly typed invokedynamic

        InvokeDynamic.hail2("dynamic invocation of missing method"); // Weakly typed invokedynamic
    }

    static void greeter(String x) {
        System.out.println("Hello, " + x);
    }

    static MethodHandle greeterMethodHandle = MethodHandles.lookup().findStatic(
        DynamicInvocation.class, "greeter", MethodType.methodType(void.class, String.class));


    // Set up a class-local bootstrap method
    static {
        Linkage.registerBootstrapMethod("bootstrapDynamic");
    }

    private static CallSite bootstrapDynamic(Class caller, String name, MethodType type) {
        if (type.parameterCount() == 1 && name == "hail") {
            MethodHandle target = MethodHandles.convertArguments(greeterMethodHandle, type);
            CallSite site = new CallSite(caller, name, type);
            site.setTarget(target);
            System.out.println("Set the CallSite target to the method " + greeterMethodHandle);
            return site;
        }
        else {
            System.out.println("Trying to invoke invalid method: " + name);
            return null;
        }
    }
}
